What's the purpose of “true” in bash “if sudo true; then” Unicorn Meta Zoo #1: Why another podcast? Announcing the arrival of Valued Associate #679: Cesar Manara 2019 Community Moderator Election Results Why I closed the “Why is Kali so hard” questionHow can I adjust this short shell script to fit my needs?Security of sudo not asking for a password after the first timeCan't give myself NOPASSWD privelege for chmod/chownHow to prevent the caller's shell from being used in sudoScript that asks for four words, then tells the user the word they chose. Output error?Sudo specific command with no passwordHave a command in my $PATH, but it is not being recognized when I use sudoHow to check a set of lines in a text file for patterns using awk, sed, or grep?Which user's password does `sudo` asks for?Does sudo restrict on which users can acquire superuser privileges?

Reattaching fallen shelf to wall?

Israeli soda type drink

Suing a Police Officer Instead of the Police Department

Why did C use the -> operator instead of reusing the . operator?

Is accepting an invalid credit card number a security issue?

Scheduling based problem

Which big number is bigger?

Raising a bilingual kid. When should we introduce the majority language?

How to have a sharp product image?

What is this word supposed to be?

What is the best way to deal with NPC-NPC combat?

How can I wire a 9-position switch so that each position turns on one more LED than the one before?

What does a straight horizontal line above a few notes, after a changed tempo mean?

Check if a string is entirely made of the same substring

Is there any pythonic way to find average of specific tuple elements in array?

Why doesn't the standard consider a template constructor as a copy constructor?

How to avoid introduction cliches

What’s with the clanks at the end of the credits in Avengers: Endgame?

C++ diamond problem - How to call base method only once

What is /etc/mtab in Linux?

finding a tangent line to a parabola

What makes accurate emulation of old systems a difficult task?

Did the Roman Empire have penal colonies?

Was Dennis Ritchie being too modest in this quote about C and Pascal?



What's the purpose of “true” in bash “if sudo true; then”



Unicorn Meta Zoo #1: Why another podcast?
Announcing the arrival of Valued Associate #679: Cesar Manara
2019 Community Moderator Election Results
Why I closed the “Why is Kali so hard” questionHow can I adjust this short shell script to fit my needs?Security of sudo not asking for a password after the first timeCan't give myself NOPASSWD privelege for chmod/chownHow to prevent the caller's shell from being used in sudoScript that asks for four words, then tells the user the word they chose. Output error?Sudo specific command with no passwordHave a command in my $PATH, but it is not being recognized when I use sudoHow to check a set of lines in a text file for patterns using awk, sed, or grep?Which user's password does `sudo` asks for?Does sudo restrict on which users can acquire superuser privileges?



.everyoneloves__top-leaderboard:empty,.everyoneloves__mid-leaderboard:empty,.everyoneloves__bot-mid-leaderboard:empty margin-bottom:0;








19















I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question



















  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    Mar 26 at 14:47







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    Mar 26 at 14:52






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    Mar 26 at 14:55






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    Mar 26 at 15:15






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    Mar 26 at 17:24


















19















I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question



















  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    Mar 26 at 14:47







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    Mar 26 at 14:52






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    Mar 26 at 14:55






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    Mar 26 at 15:15






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    Mar 26 at 17:24














19












19








19








I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question
















I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement?



I need to invert the test on the fourth line, how do I do so? Here is what I've tried:



if sudo false; then 
if sudo true == false; then
if [!(sudo true)]; then






bash sudo






share|improve this question















share|improve this question













share|improve this question




share|improve this question








edited Mar 27 at 12:00







Matt Parkins

















asked Mar 26 at 14:43









Matt ParkinsMatt Parkins

20727




20727







  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    Mar 26 at 14:47







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    Mar 26 at 14:52






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    Mar 26 at 14:55






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    Mar 26 at 15:15






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    Mar 26 at 17:24













  • 2





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    Mar 26 at 14:47







  • 4





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    Mar 26 at 14:52






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    Mar 26 at 14:55






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    Mar 26 at 15:15






  • 2





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    Mar 26 at 17:24








2




2





If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

– Matt Parkins
Mar 26 at 14:47






If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

– Matt Parkins
Mar 26 at 14:47





4




4





Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

– Jeff Schaller
Mar 26 at 14:52





Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

– Jeff Schaller
Mar 26 at 14:52




1




1





see stackoverflow.com/q/10552711/537980

– ctrl-alt-delor
Mar 26 at 14:55





see stackoverflow.com/q/10552711/537980

– ctrl-alt-delor
Mar 26 at 14:55




1




1





@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

– Matt Parkins
Mar 26 at 15:15





@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

– Matt Parkins
Mar 26 at 15:15




2




2





In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

– Toby Speight
Mar 26 at 17:24






In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

– Toby Speight
Mar 26 at 17:24











3 Answers
3






active

oldest

votes


















38














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer


















  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 31





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 3





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 2





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 2





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15


















20














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer


















  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13


















5














As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.






share|improve this answer




















  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29











Your Answer








StackExchange.ready(function()
var channelOptions =
tags: "".split(" "),
id: "106"
;
initTagRenderer("".split(" "), "".split(" "), channelOptions);

StackExchange.using("externalEditor", function()
// Have to fire editor after snippets, if snippets enabled
if (StackExchange.settings.snippets.snippetsEnabled)
StackExchange.using("snippets", function()
createEditor();
);

else
createEditor();

);

function createEditor()
StackExchange.prepareEditor(
heartbeatType: 'answer',
autoActivateHeartbeat: false,
convertImagesToLinks: false,
noModals: true,
showLowRepImageUploadWarning: true,
reputationToPostImages: null,
bindNavPrevention: true,
postfix: "",
imageUploader:
brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
allowUrls: true
,
onDemand: true,
discardSelector: ".discard-answer"
,immediatelyShowMarkdownHelp:true
);



);













draft saved

draft discarded


















StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');

);

Post as a guest















Required, but never shown

























3 Answers
3






active

oldest

votes








3 Answers
3






active

oldest

votes









active

oldest

votes






active

oldest

votes









38














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer


















  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 31





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 3





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 2





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 2





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15















38














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer


















  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 31





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 3





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 2





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 2





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15













38












38








38







true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer













true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;






share|improve this answer












share|improve this answer



share|improve this answer










answered Mar 26 at 14:58









JShorthouseJShorthouse

54829




54829







  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 31





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 3





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 2





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 2





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15












  • 12





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    Mar 26 at 19:11







  • 31





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    Mar 26 at 19:14







  • 3





    @IMSoP That's deep.

    – brainplot
    Mar 27 at 12:54






  • 2





    If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

    – nigel222
    Mar 27 at 17:22






  • 2





    In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

    – Lee Daniel Crocker
    Mar 27 at 20:15







12




12





As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

– IMSoP
Mar 26 at 19:11






As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

– IMSoP
Mar 26 at 19:11





31




31





PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

– IMSoP
Mar 26 at 19:14






PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

– IMSoP
Mar 26 at 19:14





3




3





@IMSoP That's deep.

– brainplot
Mar 27 at 12:54





@IMSoP That's deep.

– brainplot
Mar 27 at 12:54




2




2





If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

– nigel222
Mar 27 at 17:22





If true didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.

– nigel222
Mar 27 at 17:22




2




2





In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

– Lee Daniel Crocker
Mar 27 at 20:15





In AT&T SYSV Unix, "true" was a shell script /bin/true, which consisted of a large copyright notice in comments...and nothing else.

– Lee Daniel Crocker
Mar 27 at 20:15













20














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer


















  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13















20














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer


















  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13













20












20








20







I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer













I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.







share|improve this answer












share|improve this answer



share|improve this answer










answered Mar 26 at 22:32









MehrdadMehrdad

1,41641834




1,41641834







  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13












  • 1





    Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

    – Sergiy Kolodyazhnyy
    Mar 27 at 3:32






  • 3





    Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

    – Mehrdad
    Mar 27 at 3:38







  • 1





    The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

    – mckenzm
    Mar 27 at 4:10






  • 2





    And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

    – Dave Sherohman
    Mar 27 at 14:42






  • 2





    Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

    – jrw32982
    Mar 27 at 19:13







1




1





Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

– Sergiy Kolodyazhnyy
Mar 27 at 3:32





Essentially, this. Alternative could be to check if the user is in sudoers group, but just running sudo true is also easy enough of a way, although a bit hacky.

– Sergiy Kolodyazhnyy
Mar 27 at 3:32




3




3





Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

– Mehrdad
Mar 27 at 3:38






Note that this also requires sudo to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)

– Mehrdad
Mar 27 at 3:38





1




1





The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

– mckenzm
Mar 27 at 4:10





The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.

– mckenzm
Mar 27 at 4:10




2




2





And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

– Dave Sherohman
Mar 27 at 14:42





And, conversely, you can also be able to sudo without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers. But even sudo true is not infallible, as sudo access can be granted for only specific commands, so you may be able to sudo true, but not to sudo something_else, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo.

– Dave Sherohman
Mar 27 at 14:42




2




2





Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

– jrw32982
Mar 27 at 19:13





Also, you can be in the sudoers group and not be able to sudo because the sudoers group is not listed in the sudoers file. A group with the four letters sudo in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo.

– jrw32982
Mar 27 at 19:13











5














As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.






share|improve this answer




















  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29















5














As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.






share|improve this answer




















  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29













5












5








5







As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.






share|improve this answer















As I see in this script. It is just checking if sudo is enabled, that is it..



true just returns true.



So in this case if they need to run any command with sudo it checks at start first, asking the password only one time.



The condition works like this: if sudo are executing the true command correctly, it will return true for the if condition, then sudo is enabled and the user typed the password correctly, else you typed the password wrong or sudo is not enabled, the script must not continue.



The other commands do not need to ask sudo password, because your authentication are sucessfully in first time (but this depends on the sudo configuration, so this scripts depends much in the environment configuration)



The 'echo password ok' demonstrate that too. the shell script will not ask the password anymore.







share|improve this answer














share|improve this answer



share|improve this answer








edited Mar 26 at 15:06

























answered Mar 26 at 14:55









Luciano Andress MartiniLuciano Andress Martini

4,2151238




4,2151238







  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29












  • 1





    The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

    – ilkkachu
    Mar 26 at 15:10











  • I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

    – Luciano Andress Martini
    Mar 26 at 15:29







1




1





The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

– ilkkachu
Mar 26 at 15:10





The only commands that run through sudo there are sudo true and sudo -k. The latter explicitly doesn't require a password. None of the other commands in the script run via sudo, so of course they will not require passwords, regardless of if the authentication was successful the first time.

– ilkkachu
Mar 26 at 15:10













I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

– Luciano Andress Martini
Mar 26 at 15:29





I wrote: "So in this case if they need to run any command with sudo it checks at start first, asking the password only one time. "

– Luciano Andress Martini
Mar 26 at 15:29

















draft saved

draft discarded
















































Thanks for contributing an answer to Unix & Linux Stack Exchange!


  • Please be sure to answer the question. Provide details and share your research!

But avoid


  • Asking for help, clarification, or responding to other answers.

  • Making statements based on opinion; back them up with references or personal experience.

To learn more, see our tips on writing great answers.




draft saved


draft discarded














StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');

);

Post as a guest















Required, but never shown





















































Required, but never shown














Required, but never shown












Required, but never shown







Required, but never shown

































Required, but never shown














Required, but never shown












Required, but never shown







Required, but never shown







Popular posts from this blog

Færeyskur hestur Heimild | Tengill | Tilvísanir | LeiðsagnarvalRossið - síða um færeyska hrossið á færeyskuGott ár hjá færeyska hestinum

He _____ here since 1970 . Answer needed [closed]What does “since he was so high” mean?Meaning of “catch birds for”?How do I ensure “since” takes the meaning I want?“Who cares here” meaningWhat does “right round toward” mean?the time tense (had now been detected)What does the phrase “ring around the roses” mean here?Correct usage of “visited upon”Meaning of “foiled rail sabotage bid”It was the third time I had gone to Rome or It is the third time I had been to Rome

Slayer Innehåll Historia | Stil, komposition och lyrik | Bandets betydelse och framgångar | Sidoprojekt och samarbeten | Kontroverser | Medlemmar | Utmärkelser och nomineringar | Turnéer och festivaler | Diskografi | Referenser | Externa länkar | Navigeringsmenywww.slayer.net”Metal Massacre vol. 1””Metal Massacre vol. 3””Metal Massacre Volume III””Show No Mercy””Haunting the Chapel””Live Undead””Hell Awaits””Reign in Blood””Reign in Blood””Gold & Platinum – Reign in Blood””Golden Gods Awards Winners”originalet”Kerrang! Hall Of Fame””Slayer Looks Back On 37-Year Career In New Video Series: Part Two””South of Heaven””Gold & Platinum – South of Heaven””Seasons in the Abyss””Gold & Platinum - Seasons in the Abyss””Divine Intervention””Divine Intervention - Release group by Slayer””Gold & Platinum - Divine Intervention””Live Intrusion””Undisputed Attitude””Abolish Government/Superficial Love””Release “Slatanic Slaughter: A Tribute to Slayer” by Various Artists””Diabolus in Musica””Soundtrack to the Apocalypse””God Hates Us All””Systematic - Relationships””War at the Warfield””Gold & Platinum - War at the Warfield””Soundtrack to the Apocalypse””Gold & Platinum - Still Reigning””Metallica, Slayer, Iron Mauden Among Winners At Metal Hammer Awards””Eternal Pyre””Eternal Pyre - Slayer release group””Eternal Pyre””Metal Storm Awards 2006””Kerrang! Hall Of Fame””Slayer Wins 'Best Metal' Grammy Award””Slayer Guitarist Jeff Hanneman Dies””Bullet-For My Valentine booed at Metal Hammer Golden Gods Awards””Unholy Aliance””The End Of Slayer?””Slayer: We Could Thrash Out Two More Albums If We're Fast Enough...””'The Unholy Alliance: Chapter III' UK Dates Added”originalet”Megadeth And Slayer To Co-Headline 'Canadian Carnage' Trek”originalet”World Painted Blood””Release “World Painted Blood” by Slayer””Metallica Heading To Cinemas””Slayer, Megadeth To Join Forces For 'European Carnage' Tour - Dec. 18, 2010”originalet”Slayer's Hanneman Contracts Acute Infection; Band To Bring In Guest Guitarist””Cannibal Corpse's Pat O'Brien Will Step In As Slayer's Guest Guitarist”originalet”Slayer’s Jeff Hanneman Dead at 49””Dave Lombardo Says He Made Only $67,000 In 2011 While Touring With Slayer””Slayer: We Do Not Agree With Dave Lombardo's Substance Or Timeline Of Events””Slayer Welcomes Drummer Paul Bostaph Back To The Fold””Slayer Hope to Unveil Never-Before-Heard Jeff Hanneman Material on Next Album””Slayer Debut New Song 'Implode' During Surprise Golden Gods Appearance””Release group Repentless by Slayer””Repentless - Slayer - Credits””Slayer””Metal Storm Awards 2015””Slayer - to release comic book "Repentless #1"””Slayer To Release 'Repentless' 6.66" Vinyl Box Set””BREAKING NEWS: Slayer Announce Farewell Tour””Slayer Recruit Lamb of God, Anthrax, Behemoth + Testament for Final Tour””Slayer lägger ner efter 37 år””Slayer Announces Second North American Leg Of 'Final' Tour””Final World Tour””Slayer Announces Final European Tour With Lamb of God, Anthrax And Obituary””Slayer To Tour Europe With Lamb of God, Anthrax And Obituary””Slayer To Play 'Last French Show Ever' At Next Year's Hellfst””Slayer's Final World Tour Will Extend Into 2019””Death Angel's Rob Cavestany On Slayer's 'Farewell' Tour: 'Some Of Us Could See This Coming'””Testament Has No Plans To Retire Anytime Soon, Says Chuck Billy””Anthrax's Scott Ian On Slayer's 'Farewell' Tour Plans: 'I Was Surprised And I Wasn't Surprised'””Slayer””Slayer's Morbid Schlock””Review/Rock; For Slayer, the Mania Is the Message””Slayer - Biography””Slayer - Reign In Blood”originalet”Dave Lombardo””An exclusive oral history of Slayer”originalet”Exclusive! Interview With Slayer Guitarist Jeff Hanneman”originalet”Thinking Out Loud: Slayer's Kerry King on hair metal, Satan and being polite””Slayer Lyrics””Slayer - Biography””Most influential artists for extreme metal music””Slayer - Reign in Blood””Slayer guitarist Jeff Hanneman dies aged 49””Slatanic Slaughter: A Tribute to Slayer””Gateway to Hell: A Tribute to Slayer””Covered In Blood””Slayer: The Origins of Thrash in San Francisco, CA.””Why They Rule - #6 Slayer”originalet”Guitar World's 100 Greatest Heavy Metal Guitarists Of All Time”originalet”The fans have spoken: Slayer comes out on top in readers' polls”originalet”Tribute to Jeff Hanneman (1964-2013)””Lamb Of God Frontman: We Sound Like A Slayer Rip-Off””BEHEMOTH Frontman Pays Tribute To SLAYER's JEFF HANNEMAN””Slayer, Hatebreed Doing Double Duty On This Year's Ozzfest””System of a Down””Lacuna Coil’s Andrea Ferro Talks Influences, Skateboarding, Band Origins + More””Slayer - Reign in Blood””Into The Lungs of Hell””Slayer rules - en utställning om fans””Slayer and Their Fans Slashed Through a No-Holds-Barred Night at Gas Monkey””Home””Slayer””Gold & Platinum - The Big 4 Live from Sofia, Bulgaria””Exclusive! Interview With Slayer Guitarist Kerry King””2008-02-23: Wiltern, Los Angeles, CA, USA””Slayer's Kerry King To Perform With Megadeth Tonight! - Oct. 21, 2010”originalet”Dave Lombardo - Biography”Slayer Case DismissedArkiveradUltimate Classic Rock: Slayer guitarist Jeff Hanneman dead at 49.”Slayer: "We could never do any thing like Some Kind Of Monster..."””Cannibal Corpse'S Pat O'Brien Will Step In As Slayer'S Guest Guitarist | The Official Slayer Site”originalet”Slayer Wins 'Best Metal' Grammy Award””Slayer Guitarist Jeff Hanneman Dies””Kerrang! Awards 2006 Blog: Kerrang! Hall Of Fame””Kerrang! Awards 2013: Kerrang! Legend”originalet”Metallica, Slayer, Iron Maien Among Winners At Metal Hammer Awards””Metal Hammer Golden Gods Awards””Bullet For My Valentine Booed At Metal Hammer Golden Gods Awards””Metal Storm Awards 2006””Metal Storm Awards 2015””Slayer's Concert History””Slayer - Relationships””Slayer - Releases”Slayers officiella webbplatsSlayer på MusicBrainzOfficiell webbplatsSlayerSlayerr1373445760000 0001 1540 47353068615-5086262726cb13906545x(data)6033143kn20030215029